#!/usr/bin/perl

#
# lux4openhab.pl
# Date: 29.10.2012
# Version: 0.2
# Copyright: Thomas Hoerndlein, 2013
#

my $basepath = "/usr/local/luxtronik";
require "$basepath/lib/Luxtronik.pm";

my $param = shift @ARGV;
my $action = shift @ARGV;

open STDERR, ">/dev/null";		# Suppress outputs on STDERR

my $luxtronik = Luxtronik->new(request_retries => 20);


if ($param eq 'betriebszustand') {

	$luxtronik->update_infos;
	my $betriebszustand = $luxtronik->anlagenstatus('betriebszustand');

	if ($betriebszustand eq 'Heizen' || $betriebszustand eq 'Warmwasser') {
		print "$betriebszustand seit " . $luxtronik->ablaufzeiten('wp_seit') . "h\n";;
	} elsif ($betriebszustand eq 'Bereitschaft' || $betriebszustand eq 'EVU Sperre') {
		print "$betriebszustand seit " . $luxtronik->ablaufzeiten('vd_stand') . "h\n";;
	} else {
		print "$betriebszustand\n";;
	}

} elsif ($param eq 'vorundruecklauf') {

	$luxtronik->update_infos;
        print $luxtronik->temperaturen('aussen') . "|" .
              $luxtronik->temperaturen('vorlauf') . "|" .
              $luxtronik->temperaturen('ruecklauf') . "|" .
              $luxtronik->temperaturen('ruecklauf_soll') . "\n";

} elsif ($param eq 'heizung') {

        print $luxtronik->heizung($action) . "\n";

} elsif ($param eq 'warmwasser') {

        print $luxtronik->warmwasser($action) . "\n";

} elsif ($param eq 'heizkurve') {
	
        my $hk = $luxtronik->heizkurve();

        if (defined $action && $action =~ /[0-9]+/) {

                $hk->{'abweichung'} = $action;
                $luxtronik->heizkurve($hk);

        } else {

		my $abweichung = $hk->{'abweichung'};
		$abweichung =~ s/-/minus/;
		print "$abweichung\n";
        }

} else {
	print "Error: Wrong parameter!\n";
}


exit;
