#!/usr/bin/perl -w

#
# luxtronik.pl
# Date: 05/2012
# Version: 0.1
# Copyright: Thomas Hoerndlein, 2012
# Testskript for Luxtronik.pm
#

my $basepath = "/usr/local/luxtronik";
require "$basepath/lib/Luxtronik.pm";


#my $luxtronik = Luxtronik->new(serialport => '/dev/ttyS0');
my $luxtronik = Luxtronik->new();
$luxtronik->update_infos;

print "Temperatur Vorlauf:                     " . $luxtronik->temperaturen('vorlauf')                  . "°C\n";
print "Temperatur Ruecklauf (Soll):            " . $luxtronik->temperaturen('ruecklauf')                . "°C\n";
print "Temperatur Ruecklauf :                  " . $luxtronik->temperaturen('ruecklauf_soll')           . "°C\n";
print "Temperatur Heissgas:                    " . $luxtronik->temperaturen('heissgas')                 . "°C\n";
print "Temperatur Aussen:                      " . $luxtronik->temperaturen('aussen')                   . "°C\n";
print "Temperatur Brauchwasser (Ist):          " . $luxtronik->temperaturen('brauchwasser_ist')         . "°C\n";
print "Temperatur Brauchwasser (Soll):         " . $luxtronik->temperaturen('brauchwasser_soll')        . "°C\n";
print "Temperatur Waermequelle Ein:            " . $luxtronik->temperaturen('waermequelle_ein')         . "°C\n";
print "Temperatur Kaeltekreis:                 " . $luxtronik->temperaturen('kaeltekreis')              . "°C\n";
print "Temperatur Mischkreis 1 Vorlauf:        " . $luxtronik->temperaturen('mischkreis1_vorlauf')      . "°C\n";
print "Temperatur Mischkreis 1 Vorlauf (Soll): " . $luxtronik->temperaturen('mischkreis1_vorlauf_soll') . "°C\n";
print "Temperatur Raumstation:                 " . $luxtronik->temperaturen('raumstation')              . "°C\n";

@temperaturen =  $luxtronik->temperaturen;
print "Alle Temperaturen: "; 
foreach (@temperaturen) { print "$_ " };
print "\n\n";


print "Eingang ASD: " . $luxtronik->eingaenge('asd') . "\n";
print "Eingang EVU: " . $luxtronik->eingaenge('evu') . "\n";
print "Eingang HD:  " . $luxtronik->eingaenge('hd')  . "\n";
print "Eingang MOT: " . $luxtronik->eingaenge('mot') . "\n";
print "Eingang ND:  " . $luxtronik->eingaenge('nd')  . "\n";
print "Eingang PEX: " . $luxtronik->eingaenge('pex') . "\n";

@eingaenge =  $luxtronik->eingaenge;
print "Alle Eingaenge: "; 
foreach (@eingaenge) { print "$_ " };
print "\n\n";


print "Ausgang Abtauventil:                   " . $luxtronik->ausgaenge('abtauventil') . "\n";
print "Ausgang Brauchwasserumwaelzpumpe:      " . $luxtronik->ausgaenge('bup') . "\n";
print "Ausgang Fussbodenheizungsumwaelzpumpe: " . $luxtronik->ausgaenge('fup1') . "\n";
print "Ausgang Heizungsumwaelzpumpe:          " . $luxtronik->ausgaenge('hup') . "\n";
print "Ausgang Mischer 1 Auf:                 " . $luxtronik->ausgaenge('mischer1_auf') . "\n";
print "Ausgang Mischer 1 Zu:                  " . $luxtronik->ausgaenge('mischer1_zu') . "\n";
print "Ventilation:                           " . $luxtronik->ausgaenge('ventilation') . "\n";
print "Ventil BOSUP:                          " . $luxtronik->ausgaenge('ventil_bosup') . "\n";
print "Verdichter 1:                          " . $luxtronik->ausgaenge('verdichter1') . "\n";
print "Verdichter 2:                          " . $luxtronik->ausgaenge('verdichter2') . "\n";
print "ZUP-ZIP:                               " . $luxtronik->ausgaenge('zup_zip') . "\n";
print "ZWE1:                                  " . $luxtronik->ausgaenge('zwe1') . "\n";
print "ZWE2 SST:                              " . $luxtronik->ausgaenge('zwe2_sst') . "\n";

@ausgaenge =  $luxtronik->ausgaenge;
print "Alle Ausgaenge: "; 
foreach (@ausgaenge) { print "$_ " };
print "\n\n";


print "Ablaufzeit WP seit:                            " . $luxtronik->ablaufzeiten('wp_seit') . "\n";
print "Ablaufzeit ZWE 1 seit:                         " . $luxtronik->ablaufzeiten('zwe1_seit') . "\n";
print "Ablaufzeit ZWE 2 seit:                         " . $luxtronik->ablaufzeiten('zwe2_seit') . "\n";
print "Ablaufzeit Netzeinschaltverz.:                 " . $luxtronik->ablaufzeiten('netzeinv') . "\n";
print "Ablaufzeit Schaltspielsperre (SSP) Standzeit:  " . $luxtronik->ablaufzeiten('ssp_zeit_standzeit') . "\n";
print "Ablaufzeit Schaltspielsperre (SSP) Einschverz: " . $luxtronik->ablaufzeiten('ssp_zeit_einschverz') . "\n";
print "Ablaufzeit VD Stand:                           " . $luxtronik->ablaufzeiten('vd_stand') . "\n";
print "Ablaufzeit HRM Zeit:                           " . $luxtronik->ablaufzeiten('hrm_zeit') . "\n";
print "Ablaufzeit HRW Zeit:                           " . $luxtronik->ablaufzeiten('hrw_zeit') . "\n";
print "Ablaufzeit TDI seit:                           " . $luxtronik->ablaufzeiten('tdi_seit') . "\n";
print "Ablaufzeit Sperre BW:                          " . $luxtronik->ablaufzeiten('sperre_bw') . "\n";

@ablaufzeiten =  $luxtronik->ablaufzeiten;
print "Alle Ablaufzeiten: "; 
foreach (@ablaufzeiten) { print "$_ " };
print "\n\n";


print "Betriebsstunden VD1:         " . $luxtronik->betriebsstunden('vd1') . "\n";
print "Betriebsstunden VD1 Impulse: " . $luxtronik->betriebsstunden('vd1imp') . "\n";
print "Betriebsstunden VD1 deZ:     " . $luxtronik->betriebsstunden('vd1dez') . "\n";
print "Betriebsstunden VD2:         " . $luxtronik->betriebsstunden('vd2') . "\n";
print "Betriebsstunden VD2 Impulse: " . $luxtronik->betriebsstunden('vd2imp') . "\n";
print "Betriebsstunden VD2 deZ:     " . $luxtronik->betriebsstunden('vd2dez') . "\n";
print "Betriebsstunden ZWE1:        " . $luxtronik->betriebsstunden('zwe1') . "\n";
print "Betriebsstunden ZWE2:        " . $luxtronik->betriebsstunden('zwe2') . "\n";
print "Betriebsstunden WP:          " . $luxtronik->betriebsstunden('wp') . "\n";

@betriebsstunden =  $luxtronik->betriebsstunden;
print "Alle Betriebsstunden: "; 
foreach (@betriebsstunden) { print "$_ " };
print "\n\n";


print "Betriebssekunden VD1:         " . $luxtronik->betriebssekunden('vd1') . "\n";
print "Betriebssekunden VD1 Impulse: " . $luxtronik->betriebssekunden('vd1imp') . "\n";
print "Betriebssekunden VD1 deZ:     " . $luxtronik->betriebssekunden('vd1dez') . "\n";
print "Betriebssekunden VD2:         " . $luxtronik->betriebssekunden('vd2') . "\n";
print "Betriebssekunden VD2 Impulse: " . $luxtronik->betriebssekunden('vd2imp') . "\n";
print "Betriebssekunden VD2 deZ:     " . $luxtronik->betriebssekunden('vd2dez') . "\n";
print "Betriebssekunden ZWE1:        " . $luxtronik->betriebssekunden('zwe1') . "\n";
print "Betriebssekunden ZWE2:        " . $luxtronik->betriebssekunden('zwe2') . "\n";
print "Betriebssekunden WP:          " . $luxtronik->betriebssekunden('wp') . "\n";

@betriebssekunden =  $luxtronik->betriebssekunden;
print "Alle Betriebssekunden: "; 
foreach (@betriebssekunden) { print "$_ " };
print "\n\n";


print "Anlagenstatus WP-Typ:               " . $luxtronik->anlagenstatus('wp-typ') . "\n";
print "Anlagenstatus SW-Stand:             " . $luxtronik->anlagenstatus('sw-stand') . "\n";
print "Anlagenstatus Biv-Stufe:            " . $luxtronik->anlagenstatus('biv-stufe') . "\n";
print "Anlagenstatus Betriebszustand:      " . $luxtronik->anlagenstatus('betriebszustand') . "\n";
print "Anlagenstatus Betriebszustand Text: " . $luxtronik->anlagenstatus('betriebszustand_text') . "\n";
print "Anlagenstatus Einschaltzeitpunkt:   " . $luxtronik->anlagenstatus('einschaltzeitpunkt') . "\n";
print "Anlagenstatus Compact:              " . $luxtronik->anlagenstatus('compact') . "\n";
print "Anlagenstatus Comfort:              " . $luxtronik->anlagenstatus('comfort') . "\n";

@anlagenstatus =  $luxtronik->anlagenstatus;
print "Alle Anlagenstatus: "; 
foreach (@anlagenstatus) { print "$_ " };
print "\n\n";


print "Fehlerspeicher 0: " . $luxtronik->fehlerspeicher(0) . "\n";
print "Fehlerspeicher 1: " . $luxtronik->fehlerspeicher(1) . "\n";
print "Fehlerspeicher 2: " . $luxtronik->fehlerspeicher(2) . "\n";
print "Fehlerspeicher 3: " . $luxtronik->fehlerspeicher(3) . "\n";
print "Fehlerspeicher 4: " . $luxtronik->fehlerspeicher(4) . "\n";

@fehlerspeicher =  $luxtronik->fehlerspeicher;
print "Alle Fehlerspeicher: "; 
foreach (@fehlerspeicher) { print "$_ " };
print "\n\n";


print "Abschaltung 0: " . $luxtronik->abschaltungen(0) . "\n";
print "Abschaltung 1: " . $luxtronik->abschaltungen(1) . "\n";
print "Abschaltung 2: " . $luxtronik->abschaltungen(2) . "\n";
print "Abschaltung 3: " . $luxtronik->abschaltungen(3) . "\n";
print "Abschaltung 4: " . $luxtronik->abschaltungen(4) . "\n";
@abschaltung =  $luxtronik->abschaltungen;
print "Alle Abschaltungen: "; 
foreach (@abschaltung) { print "$_ " };
print "\n\n";


print "Abschaltung 0: " . $luxtronik->abschaltungen_text(0) . "\n";
print "Abschaltung 1: " . $luxtronik->abschaltungen_text(1) . "\n";
print "Abschaltung 2: " . $luxtronik->abschaltungen_text(2) . "\n";
print "Abschaltung 3: " . $luxtronik->abschaltungen_text(3) . "\n";
print "Abschaltung 4: " . $luxtronik->abschaltungen_text(4) . "\n";
@abschaltung_text =  $luxtronik->abschaltungen_text;
print "Alle Abschaltungen: "; 
foreach (@abschaltung_text) { print "$_ " };
print "\n\n";


print "Alle Informationen als CSV:\n" . $luxtronik->informationen('csv') . "\n\n";
@informationen =  $luxtronik->informationen;
print "Alle Informationen:\n"; 
foreach (@informationen) { print "$_ " };
print "\n\n";

print "Abfragezeit: " . localtime($luxtronik->info_time());
print "\n\n";
