#!/usr/bin/perl -w

#
# luxtronik2openhab.pl
# Date: 24.02.2015
# Version: 0.2
# Copyright: Thomas Hoerndlein, 2014
# Pumps Luxtronik parameters to openHAB
#

my $basepath = "/usr/local/luxtronik";
#use Luxtronik;
require "$basepath/lib/Luxtronik.pm";
use REST::Client;	



#my $luxtronik = Luxtronik->new(serialport => '/dev/ttyS0');
my $luxtronik = Luxtronik->new();
$luxtronik->update_infos;

%luxhash = (
		WPTemperaturVorlauf			=> $luxtronik->temperaturen('vorlauf'),		
		WPTemperaturRuecklauf			=> $luxtronik->temperaturen('ruecklauf'),		
		WPTemperaturRuecklaufSoll		=> $luxtronik->temperaturen('ruecklauf_soll'),		
		WPTemperaturHeissgas			=> $luxtronik->temperaturen('heissgas'),		
		WPTemperaturAussen			=> $luxtronik->temperaturen('aussen'),		
		WPTemperaturBrauchwasserIst		=> $luxtronik->temperaturen('brauchwasser_ist'),		
		WPTemperaturBrauchwasserSoll		=> $luxtronik->temperaturen('brauchwasser_soll'),		
		WPTemperaturWaermequelleEin		=> $luxtronik->temperaturen('waermequelle_ein'),		
		WPTemperaturKaeltekreis			=> $luxtronik->temperaturen('kaeltekreis'),		
		WPTemperaturMischkreis1Vorlauf		=> $luxtronik->temperaturen('mischkreis1_vorlauf'),		
		WPTemperaturMischkreis1VorlaufSoll	=> $luxtronik->temperaturen('mischkreis1_vorlauf_soll'),		
		WPTemperaturRaumstation			=> $luxtronik->temperaturen('raumstation'),		

		WPEingangASD				=> $luxtronik->eingaenge('asd'),		
		WPEingangEVU				=> $luxtronik->eingaenge('evu'),		
		WPEingangHD				=> $luxtronik->eingaenge('hd'),		
		WPEingangMOT				=> $luxtronik->eingaenge('mot'),		
		WPEingangND				=> $luxtronik->eingaenge('nd'),		
		WPEingangPEX				=> $luxtronik->eingaenge('pex'),		

		WPAusgangAbtauventil			=> $luxtronik->ausgaenge('abtauventil'),		
		WPAusgangBUP				=> $luxtronik->ausgaenge('bup'),		
		WPAusgangFUP1				=> $luxtronik->ausgaenge('fup1'),		
		WPAusgangHUP				=> $luxtronik->ausgaenge('hup'),		
		WPAusgangAusgangMischer1Auf		=> $luxtronik->ausgaenge('mischer1_auf'),		
		WPAusgangAusgangMischer1Zu		=> $luxtronik->ausgaenge('mischer1_zu'),		
		WPAusgangVentilation			=> $luxtronik->ausgaenge('ventilation'),		
		WPAusgangVentilBOSUP			=> $luxtronik->ausgaenge('ventil_bosup'),		
		WPAusgangVerdichter1			=> $luxtronik->ausgaenge('verdichter1'),		
		WPAusgangVerdichter2			=> $luxtronik->ausgaenge('verdichter2'),		
		WPAusgangZUPZIP				=> $luxtronik->ausgaenge('zup_zip'),		
		WPAusgangZWE1				=> $luxtronik->ausgaenge('zwe1'),		
		WPAusgangZWE2SST			=> $luxtronik->ausgaenge('zwe2_sst'),		

		WPAblaufzeitWPSeit			=> $luxtronik->ablaufzeiten('wp_seit'),		
		WPAblaufzeitZWE1Seit			=> $luxtronik->ablaufzeiten('zwe1_seit'),		
		WPAblaufzeitZWE2Seit			=> $luxtronik->ablaufzeiten('zwe2_seit'),		
		WPAblaufzeitNetzeinschv			=> $luxtronik->ablaufzeiten('netzeinv'),		
		WPAblaufzeitSSPZeitStandzeit		=> $luxtronik->ablaufzeiten('ssp_zeit_standzeit'),		
		WPAblaufzeitSSPZeitEinschverz		=> $luxtronik->ablaufzeiten('ssp_zeit_einschverz'),		
		WPAblaufzeitVDStand			=> $luxtronik->ablaufzeiten('vd_stand'),		
		WPAblaufzeitHRMZeit			=> $luxtronik->ablaufzeiten('hrm_zeit'),		
		WPAblaufzeitHRWZeit			=> $luxtronik->ablaufzeiten('hrw_zeit'),		
		WPAblaufzeitTDIZeit			=> $luxtronik->ablaufzeiten('tdi_seit'),		
		WPAblaufzeitSperreTDI			=> $luxtronik->ablaufzeiten('sperre_bw'),		

		WPBetriebsstundenVD1			=> $luxtronik->betriebsstunden('vd1'),
		WPBetriebsstundenVD1Imp			=> $luxtronik->betriebsstunden('vd1imp'),
		WPBetriebsstundenVD1DEZ			=> $luxtronik->betriebsstunden('vd1dez'),
		WPBetriebsstundenVD2			=> $luxtronik->betriebsstunden('vd2'),
		WPBetriebsstundenVD2Imp			=> $luxtronik->betriebsstunden('vd2imp'),
		WPBetriebsstundenVD2DEZ			=> $luxtronik->betriebsstunden('vd2dez'),
		WPBetriebsstundenZWE1			=> $luxtronik->betriebsstunden('zwe1'),
		WPBetriebsstundenZWE2			=> $luxtronik->betriebsstunden('zwe2'),
		WPBetriebsstundenWP			=> $luxtronik->betriebsstunden('wp'),

		WPBetriebssekundenVD1			=> $luxtronik->betriebssekunden('vd1'),
		WPBetriebssekundenVD1DEZ		=> $luxtronik->betriebssekunden('vd1dez'),
		WPBetriebssekundenVD2			=> $luxtronik->betriebssekunden('vd2'),
		WPBetriebssekundenVD2DEZ		=> $luxtronik->betriebssekunden('vd2dez'),
		WPBetriebssekundenZWE1			=> $luxtronik->betriebssekunden('zwe1'),
		WPBetriebssekundenZWE2			=> $luxtronik->betriebssekunden('zwe2'),
		WPBetriebssekundenWP			=> $luxtronik->betriebssekunden('wp'),

		WPAnlagenstatusWPTyp			=> $luxtronik->anlagenstatus('wp-typ'),
		WPAnlagenstatusSWStand			=> $luxtronik->anlagenstatus('sw-stand'),
		WPAnlagenstatusBivStufe			=> $luxtronik->anlagenstatus('biv-stufe'),
		WPAnlagenstatusBetriebszustand		=> $luxtronik->anlagenstatus('betriebszustand'),
		WPAnlagenstatusBetriebszustandText	=> $luxtronik->anlagenstatus('betriebszustand_text'),
		WPAnlagenstatusEinschaltzeitpunkt	=> $luxtronik->anlagenstatus('einschaltzeitpunkt'),
		WPAnlagenstatusCompact			=> $luxtronik->anlagenstatus('compact'),
		WPAnlagenstatusComfort			=> $luxtronik->anlagenstatus('comfort'),

		WPFehlerspeicher0			=> $luxtronik->fehlerspeicher(0),
		WPFehlerspeicher1			=> $luxtronik->fehlerspeicher(1),
		WPFehlerspeicher2			=> $luxtronik->fehlerspeicher(2),
		WPFehlerspeicher3			=> $luxtronik->fehlerspeicher(3),
		WPFehlerspeicher4			=> $luxtronik->fehlerspeicher(4),

		WPAbschaltung0				=> $luxtronik->abschaltungen(0),
		WPAbschaltung1				=> $luxtronik->abschaltungen(1),
		WPAbschaltung2				=> $luxtronik->abschaltungen(2),
		WPAbschaltung3				=> $luxtronik->abschaltungen(3),
		WPAbschaltung4				=> $luxtronik->abschaltungen(4),

		WPAbschaltungText0			=> $luxtronik->abschaltungen_text(0),
		WPAbschaltungText1			=> $luxtronik->abschaltungen_text(1),
		WPAbschaltungText2			=> $luxtronik->abschaltungen_text(2),
		WPAbschaltungText3			=> $luxtronik->abschaltungen_text(3),
		WPAbschaltungText4			=> $luxtronik->abschaltungen_text(4),

		WPBetriebsartHeizung			=> $luxtronik->heizung(),
		WPBetriebsartWarmwasser			=> $luxtronik->warmwasser(),

		WPInfoTime				=> $luxtronik->info_time,
		WPInfoUhrzeit				=> scalar(localtime($luxtronik->info_time)),

);
 
my $client = REST::Client->new();
$client->setHost('http://localhost:8080');
  
for my $key (keys %luxhash) {
	$client->PUT('/rest/items/' . $key . '/state', $luxhash{$key});
        if( $client->responseCode() eq '200' ){
		print "$key updated to $luxhash{$key}\n";
	} else {
		print "Error: $key: $luxhash{$key}, Response-Code: " . $client->responseCode() . "\n";
	}
}
